<?php

namespace App\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Notifications\Messages\MailMessage;
use Illuminate\Notifications\Notification;

use Modules\Main\Models\Deal\Deal;
use Modules\Main\Models\Deal\DealStatus;

class UniqueContact extends Notification
{
    use Queueable;
    private $deal;
    /**
     * Create a new notification instance.
     */
    public function __construct(Deal $deal)
    {
        if ($deal->status != DealStatus::UNIQUE)
        {
            //throw new \Exception('Notification sending: deal is not unique');
        }
        $this->deal = $deal;
    }

    /**
     * Get the notification's delivery channels.
     *
     * @return array<int, string>
     */
    public function via(object $notifiable): array
    {
        return ['database'];
    }

    /**
     * Get the mail representation of the notification.
     */
    public function toMail(object $notifiable): MailMessage
    {
        return (new MailMessage)
            ->from(env('MAIL_FROM_ADDRESS'), config('app.name', 'Партнерский кабинет'))
            ->line('The introduction to the notification.')
            ->action('Notification Action', url('/'))
            ->line('Thank you for using our application!');
    }

    /**
     * Get the array representation of the notification.
     *
     * @return array<string, mixed>
     */
    public function toArray(object $notifiable): array
    {
        $clientsPhones = $this->deal->clients->pluck('phone')->toArray();
        $clientsNames = $this->deal->clients->pluck('name')->toArray();
        foreach ($clientsNames as $key=>$name) {
            $clientsNames[$key] = $name . ' ' . $clientsPhones[$key] .'';
        }
        return [
            'deal' => $this->deal->id,
            'text' => __('notifications.' . get_class($this), 
            [
                'contact' => implode(', ', $clientsNames),
                'complex' => $this->deal->complex->name,
            ])
        ];
    }
}
